/* 

    umesh2dgui, a GUI for umesh2d grid generator 

    Copyright (C) 2007 Gabriele Dini Ciacci

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <u2d_display_set.h>
#include <stdlib.h>

u2d_Display_Set::u2d_Display_Set() {

  display_list = 0;

  vertex_type = 0;
  topology_type = 0;
  red = 0;
  green = 0;
  blue = 0;
  line_width = 1;

  coord_per_vertex = 0;

}

u2d_Display_Set::~u2d_Display_Set() {
}

GLfloat *u2d_Display_Set::Get_Vertex_Array() {
    return &vertex_array.front();
}

void u2d_Display_Set::Push_Coord(GLfloat a) {
    vertex_array.push_back(a);
}

void u2d_Display_Set::Push_Coord(GLfloat a, GLfloat b) {
    vertex_array.push_back(a);
    vertex_array.push_back(b);
}

void u2d_Display_Set::Push_Coord(GLfloat a, GLfloat b, GLfloat c) {
    vertex_array.push_back(a);
    vertex_array.push_back(b);
    vertex_array.push_back(c);
}

void u2d_Display_Set::Set_Coord_Per_Vertex(GLint m_coord_per_vertex) {
    coord_per_vertex = m_coord_per_vertex;
}

GLint u2d_Display_Set::Get_Coord_Per_Vertex() {
    return coord_per_vertex;
}

GLsizei u2d_Display_Set::Get_Vertex_Count() {
    if(coord_per_vertex == 0) return 0;
    return vertex_array.size()/coord_per_vertex;
}

GLfloat *u2d_Display_Set::Get_Topology_Array() {
    return &topology.front();
}

void u2d_Display_Set::Set_Coord_Per_Topology(GLint m_coord_per_topology) {
    coord_per_topology = m_coord_per_topology;
}

GLint u2d_Display_Set::Get_Coord_Per_Topology() {
    return coord_per_topology;
}

GLsizei u2d_Display_Set::Get_Topology_Count() {
    if(coord_per_topology == 0) return 0;
    return topology.size()/coord_per_topology;
}

void u2d_Display_Set::Push_Topology_Coord(GLfloat a) {
    topology.push_back(a);
}

void u2d_Display_Set::Push_Topology_Coord(GLfloat a, GLfloat b) {
    topology.push_back(a);
    topology.push_back(b);
}

void u2d_Display_Set::Push_Topology_Coord(GLfloat a, GLfloat b, GLfloat c) {
    topology.push_back(a);
    topology.push_back(b);
    topology.push_back(c);
}
